Skip to main content

Class AggregateGroupByRequest.Options

java.lang.Object
com.gpudb.protocol.AggregateGroupByRequest.Options
Enclosing class:

public static final class AggregateGroupByRequest.Options extends Object
A set of string constants for the AggregateGroupByRequest parameter options.

Optional parameters.

  • Field Details

    • CREATE_TEMP_TABLE

      public static final String CREATE_TEMP_TABLE
      If TRUE, a unique temporary table name will be generated in the sys_temp schema and used in place of RESULT_TABLE. If RESULT_TABLE_PERSIST is FALSE (or unspecified), then this is always allowed even if the caller does not have permission to create tables. The generated name is returned in QUALIFIED_RESULT_TABLE_NAME. Supported values:The default value is FALSE.
    • TRUE

      public static final String TRUE
    • FALSE

      public static final String FALSE
    • COLLECTION_NAME

      public static final String COLLECTION_NAME
      [DEPRECATED—please specify the containing schema as part of RESULT_TABLE and use GPUdb.createSchema to create the schema if non-existent] Name of a schema which is to contain the table specified in RESULT_TABLE. If the schema provided is non-existent, it will be automatically created.
    • EXPRESSION

      public static final String EXPRESSION
      Filter expression to apply to the table prior to computing the aggregate group by.
    • PIPELINED_EXPRESSION_EVALUATION

      public static final String PIPELINED_EXPRESSION_EVALUATION
      Evaluate the group-by during last JoinedSet filter plan step. Supported values:The default value is FALSE.
    • HAVING

      public static final String HAVING
      Filter expression to apply to the aggregated results.
    • SORT_ORDER

      public static final String SORT_ORDER
      [DEPRECATED—use order_by instead] String indicating how the returned values should be sorted - ascending or descending. Supported values:
      • ASCENDING: Indicates that the returned values should be sorted in ascending order.
      • DESCENDING: Indicates that the returned values should be sorted in descending order.
      The default value is ASCENDING.
    • ASCENDING

      public static final String ASCENDING
      Indicates that the returned values should be sorted in ascending order.
    • DESCENDING

      public static final String DESCENDING
      Indicates that the returned values should be sorted in descending order.
    • SORT_BY

      public static final String SORT_BY
      [DEPRECATED—use order_by instead] String determining how the results are sorted. Supported values:
      • KEY: Indicates that the returned values should be sorted by key, which corresponds to the grouping columns. If you have multiple grouping columns (and are sorting by key), it will first sort the first grouping column, then the second grouping column, etc.
      • VALUE: Indicates that the returned values should be sorted by value, which corresponds to the aggregates. If you have multiple aggregates (and are sorting by value), it will first sort by the first aggregate, then the second aggregate, etc.
      The default value is VALUE.
    • KEY

      public static final String KEY
      Indicates that the returned values should be sorted by key, which corresponds to the grouping columns. If you have multiple grouping columns (and are sorting by key), it will first sort the first grouping column, then the second grouping column, etc.
    • VALUE

      public static final String VALUE
      Indicates that the returned values should be sorted by value, which corresponds to the aggregates. If you have multiple aggregates (and are sorting by value), it will first sort by the first aggregate, then the second aggregate, etc.
    • ORDER_BY

      public static final String ORDER_BY
      Comma-separated list of the columns to be sorted by as well as the sort direction, e.g., ‘timestamp asc, x desc’. The default value is ”.
    • STRATEGY_DEFINITION

      public static final String STRATEGY_DEFINITION
      The tier strategy for the table and its columns.
    • COMPRESSION_CODEC

      public static final String COMPRESSION_CODEC
      The default compression codec for the result table’s columns.
    • RESULT_TABLE

      public static final String RESULT_TABLE
      The name of a table used to store the results, in [schema_name.]table_name format, using standard name resolution rules and meeting table naming criteria. Column names (group-by and aggregate fields) need to be given aliases e.g. [“FChar256 as fchar256”, “sum(FDouble) as sfd”]. If present, no results are returned in the response. This option is not available if one of the grouping attributes is an unrestricted string (i.e.; not charN) type.
    • RESULT_TABLE_PERSIST

      public static final String RESULT_TABLE_PERSIST
      If TRUE, then the result table specified in RESULT_TABLE will be persisted and will not expire unless a TTL is specified. If FALSE, then the result table will be an in-memory table and will expire unless a TTL is specified otherwise. Supported values:The default value is FALSE.
    • RESULT_TABLE_FORCE_REPLICATED

      public static final String RESULT_TABLE_FORCE_REPLICATED
      Force the result table to be replicated (ignores any sharding). Must be used in combination with the RESULT_TABLE option. Supported values:The default value is FALSE.
    • RESULT_TABLE_GENERATE_PK

      public static final String RESULT_TABLE_GENERATE_PK
      If TRUE then set a primary key for the result table. Must be used in combination with the RESULT_TABLE option. Supported values:The default value is FALSE.
    • RESULT_TABLE_GENERATE_SOFT_PK

      public static final String RESULT_TABLE_GENERATE_SOFT_PK
      If TRUE then set a soft primary key for the result table. Must be used in combination with the RESULT_TABLE option. Supported values:The default value is FALSE.
    • TTL

      public static final String TTL
      Sets the TTL of the table specified in RESULT_TABLE.
    • CHUNK_SIZE

      public static final String CHUNK_SIZE
      Indicates the number of records per chunk to be used for the result table. Must be used in combination with the RESULT_TABLE option.
    • CHUNK_COLUMN_MAX_MEMORY

      public static final String CHUNK_COLUMN_MAX_MEMORY
      Indicates the target maximum data size for each column in a chunk to be used for the result table. Must be used in combination with the RESULT_TABLE option.
    • CHUNK_MAX_MEMORY

      public static final String CHUNK_MAX_MEMORY
      Indicates the target maximum data size for all columns in a chunk to be used for the result table. Must be used in combination with the RESULT_TABLE option.
    • CREATE_INDEXES

      public static final String CREATE_INDEXES
      Comma-separated list of columns on which to create indexes on the result table. Must be used in combination with the RESULT_TABLE option.
    • PARTITION_TYPE

      public static final String PARTITION_TYPE
      Partitioning scheme to use for the result table. Supported values:
    • RANGE

      public static final String RANGE
    • INTERVAL

      public static final String INTERVAL
    • LIST

      public static final String LIST
    • HASH

      public static final String HASH
    • SERIES

      public static final String SERIES
    • PARTITION_KEYS

      public static final String PARTITION_KEYS
      Comma-separated list of partition keys, which are the columns or column expressions by which records will be assigned to partitions defined by PARTITION_DEFINITIONS.
    • PARTITION_DEFINITIONS

      public static final String PARTITION_DEFINITIONS
      Comma-separated list of partition definitions, whose format depends on the choice of PARTITION_TYPE. See range partitioning, interval partitioning, list partitioning, hash partitioning, or series partitioning for example formats.
    • IS_AUTOMATIC_PARTITION

      public static final String IS_AUTOMATIC_PARTITION
      If TRUE, a new partition will be created for values which don’t fall into an existing partition. Currently only supported for list partitions. Supported values:The default value is FALSE.
    • VIEW_ID

      public static final String VIEW_ID
      ID of view of which the result table will be a member. The default value is ”.
    • PIVOT

      public static final String PIVOT
      Pivot column.
    • PIVOT_VALUES

      public static final String PIVOT_VALUES
      Comma-separated list of the values in the PIVOT column. The list provided will become the column header prefixes in the output.
    • GROUPING_SETS

      public static final String GROUPING_SETS
      Customize the grouping attribute sets to compute the aggregates. These sets can include ROLLUP or CUBE operators. The attribute sets should be enclosed in parentheses and can include composite attributes. All attributes specified in the grouping sets must present in the group-by attributes.
    • ROLLUP

      public static final String ROLLUP
      This option is used to specify the multilevel aggregates.
    • CUBE

      public static final String CUBE
      This option is used to specify the multidimensional aggregates.
    • SHARD_KEY

      public static final String SHARD_KEY
      Comma-separated list of the columns to be sharded on; e.g. ‘column1, column2’. The columns specified must be present in columnNames. If any alias is given for any column name, the alias must be used, rather than the original column name. The default value is ”.